Package: org.apache.groovy.parser.antlr4

## [Java] Class AstBuilder

- org.apache.groovy.parser.antlr4.AstBuilder

-     public class AstBuilder
      extends org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor

  Builds the AST from the parse tree generated by Antlr4.

- - ### Constructor Summary

    Constructors
    Constructor and description
    `AstBuilder(SourceUnit sourceUnit, boolean groovydocEnabled, boolean runtimeGroovydocEnabled)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public BlockStatement` | `appendStatementsToBlockStatement(BlockStatement bs, Statement statements)`
    `` | `public ModuleNode` | `buildAST()`
    `` | `public void` | `syntaxError(Recognizer recognizer, Object offendingSymbol, int line, int charPositionInLine, String msg, RecognitionException e)`
    `` | `public Object` | `visit(ParseTree tree)` Visit tree safely, no NPE occurred when the tree is null.
    `` | `public BinaryExpression` | `visitAdditiveExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$AdditiveExprAltContext ctx)`
    `` | `public BinaryExpression` | `visitAndExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$AndExprAltContext ctx)`
    `` | `public ClassNode` | `visitAnnotatedQualifiedClassName(org.apache.groovy.parser.antlr4.GroovyParser$AnnotatedQualifiedClassNameContext ctx)`
    `` | `public AnnotationNode` | `visitAnnotation(org.apache.groovy.parser.antlr4.GroovyParser$AnnotationContext ctx)`
    `` | `public String` | `visitAnnotationName(org.apache.groovy.parser.antlr4.GroovyParser$AnnotationNameContext ctx)`
    `` | `public List<AnnotationNode>` | `visitAnnotationsOpt(org.apache.groovy.parser.antlr4.GroovyParser$AnnotationsOptContext ctx)`
    `` | `public InnerClassNode` | `visitAnonymousInnerClassDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$AnonymousInnerClassDeclarationContext ctx)`
    `` | `public Expression` | `visitArguments(org.apache.groovy.parser.antlr4.GroovyParser$ArgumentsContext ctx)`
    `` | `public List<Expression>` | `visitArrayInitializer(org.apache.groovy.parser.antlr4.GroovyParser$ArrayInitializerContext ctx)`
    `` | `public AssertStatement` | `visitAssertStatement(org.apache.groovy.parser.antlr4.GroovyParser$AssertStatementContext ctx)`
    `` | `public BinaryExpression` | `visitAssignmentExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$AssignmentExprAltContext ctx)`
    `` | `public Statement` | `visitBlock(org.apache.groovy.parser.antlr4.GroovyParser$BlockContext ctx)`
    `` | `public Statement` | `visitBlockStatement(org.apache.groovy.parser.antlr4.GroovyParser$BlockStatementContext ctx)`
    `` | `public BlockStatement` | `visitBlockStatements(org.apache.groovy.parser.antlr4.GroovyParser$BlockStatementsContext ctx)`
    `` | `public BlockStatement` | `visitBlockStatementsOpt(org.apache.groovy.parser.antlr4.GroovyParser$BlockStatementsOptContext ctx)`
    `` | `public ConstantExpression` | `visitBooleanLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser$BooleanLiteralAltContext ctx)`
    `` | `public BreakStatement` | `visitBreakStatement(org.apache.groovy.parser.antlr4.GroovyParser$BreakStatementContext ctx)`
    `` | `public VariableExpression` | `visitBuiltInType(org.apache.groovy.parser.antlr4.GroovyParser$BuiltInTypeContext ctx)`
    `` | `public CastExpression` | `visitCastExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$CastExprAltContext ctx)`
    `` | `public ClassNode` | `visitCastParExpression(org.apache.groovy.parser.antlr4.GroovyParser$CastParExpressionContext ctx)`
    `` | `public List<CatchStatement>` | `visitCatchClause(org.apache.groovy.parser.antlr4.GroovyParser$CatchClauseContext ctx)` Multi-catch(1..*) clause will be unpacked to several normal catch clauses, so the return type is List
    `` | `public List<ClassNode>` | `visitCatchType(org.apache.groovy.parser.antlr4.GroovyParser$CatchTypeContext ctx)`
    `` | `public Void` | `visitClassBody(org.apache.groovy.parser.antlr4.GroovyParser$ClassBodyContext ctx)`
    `` | `public Void` | `visitClassBodyDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$ClassBodyDeclarationContext ctx)`
    `` | `public ClassNode` | `visitClassDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$ClassDeclarationContext ctx)`
    `` | `public String` | `visitClassName(org.apache.groovy.parser.antlr4.GroovyParser$ClassNameContext ctx)`
    `` | `public ModifierNode` | `visitClassOrInterfaceModifier(org.apache.groovy.parser.antlr4.GroovyParser$ClassOrInterfaceModifierContext ctx)`
    `` | `public List<ModifierNode>` | `visitClassOrInterfaceModifiers(org.apache.groovy.parser.antlr4.GroovyParser$ClassOrInterfaceModifiersContext ctx)`
    `` | `public List<ModifierNode>` | `visitClassOrInterfaceModifiersOpt(org.apache.groovy.parser.antlr4.GroovyParser$ClassOrInterfaceModifiersOptContext ctx)`
    `` | `public ClassNode` | `visitClassOrInterfaceType(org.apache.groovy.parser.antlr4.GroovyParser$ClassOrInterfaceTypeContext ctx)`
    `` | `public Tuple2<Parameter, Expression>` | `visitClassicalForControl(org.apache.groovy.parser.antlr4.GroovyParser$ClassicalForControlContext ctx)`
    `` | `public ClosureExpression` | `visitClosure(org.apache.groovy.parser.antlr4.GroovyParser$ClosureContext ctx)`
    `` | `public ClosureExpression` | `visitClosureOrLambdaExpression(org.apache.groovy.parser.antlr4.GroovyParser$ClosureOrLambdaExpressionContext ctx)`
    `` | `public Expression` | `visitCommandArgument(org.apache.groovy.parser.antlr4.GroovyParser$CommandArgumentContext ctx)`
    `` | `public ExpressionStatement` | `visitCommandExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$CommandExprAltContext ctx)`
    `` | `public Expression` | `visitCommandExpression(org.apache.groovy.parser.antlr4.GroovyParser$CommandExpressionContext ctx)`
    `` | `public MethodNode` | `visitCompactConstructorDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$CompactConstructorDeclarationContext ctx)`
    `` | `public ModuleNode` | `visitCompilationUnit(org.apache.groovy.parser.antlr4.GroovyParser$CompilationUnitContext ctx)`
    `` | `public Expression` | `visitConditionalExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$ConditionalExprAltContext ctx)`
    `` | `public Statement` | `visitConditionalStatement(org.apache.groovy.parser.antlr4.GroovyParser$ConditionalStatementContext ctx)`
    `` | `public ContinueStatement` | `visitContinueStatement(org.apache.groovy.parser.antlr4.GroovyParser$ContinueStatementContext ctx)`
    `` | `public ClassNode` | `visitCreatedName(org.apache.groovy.parser.antlr4.GroovyParser$CreatedNameContext ctx)`
    `` | `public Expression` | `visitCreator(org.apache.groovy.parser.antlr4.GroovyParser$CreatorContext ctx)`
    `` | `public Tuple3<Expression, List<AnnotationNode>, TerminalNode>` | `visitDim(org.apache.groovy.parser.antlr4.GroovyParser$DimContext ctx)`
    `` | `public DoWhileStatement` | `visitDoWhileStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$DoWhileStmtAltContext ctx)`
    `` | `public Expression` | `visitDynamicMemberName(org.apache.groovy.parser.antlr4.GroovyParser$DynamicMemberNameContext ctx)`
    `` | `public Expression` | `visitElementValue(org.apache.groovy.parser.antlr4.GroovyParser$ElementValueContext ctx)`
    `` | `public ListExpression` | `visitElementValueArrayInitializer(org.apache.groovy.parser.antlr4.GroovyParser$ElementValueArrayInitializerContext ctx)`
    `` | `public Tuple2<String, Expression>` | `visitElementValuePair(org.apache.groovy.parser.antlr4.GroovyParser$ElementValuePairContext ctx)`
    `` | `public Map<String, Expression>` | `visitElementValuePairs(org.apache.groovy.parser.antlr4.GroovyParser$ElementValuePairsContext ctx)`
    `` | `public List<Tuple2<String, Expression>>` | `visitElementValues(org.apache.groovy.parser.antlr4.GroovyParser$ElementValuesContext ctx)`
    `` | `public List<List<AnnotationNode>>` | `visitEmptyDims(org.apache.groovy.parser.antlr4.GroovyParser$EmptyDimsContext ctx)`
    `` | `public List<List<AnnotationNode>>` | `visitEmptyDimsOpt(org.apache.groovy.parser.antlr4.GroovyParser$EmptyDimsOptContext ctx)`
    `` | `public Expression` | `visitEnhancedArgumentListElement(org.apache.groovy.parser.antlr4.GroovyParser$EnhancedArgumentListElementContext ctx)`
    `` | `public Expression` | `visitEnhancedArgumentListInPar(org.apache.groovy.parser.antlr4.GroovyParser$EnhancedArgumentListInParContext ctx)`
    `` | `public Tuple2<Parameter, Expression>` | `visitEnhancedForControl(org.apache.groovy.parser.antlr4.GroovyParser$EnhancedForControlContext ctx)`
    `` | `public Expression` | `visitEnhancedStatementExpression(org.apache.groovy.parser.antlr4.GroovyParser$EnhancedStatementExpressionContext ctx)`
    `` | `public FieldNode` | `visitEnumConstant(org.apache.groovy.parser.antlr4.GroovyParser$EnumConstantContext ctx)`
    `` | `public List<FieldNode>` | `visitEnumConstants(org.apache.groovy.parser.antlr4.GroovyParser$EnumConstantsContext ctx)`
    `` | `public BinaryExpression` | `visitEqualityExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$EqualityExprAltContext ctx)`
    `` | `public BinaryExpression` | `visitExclusiveOrExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$ExclusiveOrExprAltContext ctx)`
    `` | `public Expression` | `visitExpressionInPar(org.apache.groovy.parser.antlr4.GroovyParser$ExpressionInParContext ctx)`
    `` | `public List<Expression>` | `visitExpressionList(org.apache.groovy.parser.antlr4.GroovyParser$ExpressionListContext ctx)`
    `` | `public Expression` | `visitExpressionListElement(org.apache.groovy.parser.antlr4.GroovyParser$ExpressionListElementContext ctx)`
    `` | `public Void` | `visitFieldDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$FieldDeclarationContext ctx)`
    `` | `public Statement` | `visitFinallyBlock(org.apache.groovy.parser.antlr4.GroovyParser$FinallyBlockContext ctx)`
    `` | `public ConstantExpression` | `visitFloatingPointLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser$FloatingPointLiteralAltContext ctx)`
    `` | `public Tuple2<Parameter, Expression>` | `visitForControl(org.apache.groovy.parser.antlr4.GroovyParser$ForControlContext ctx)`
    `` | `public Expression` | `visitForInit(org.apache.groovy.parser.antlr4.GroovyParser$ForInitContext ctx)`
    `` | `public ForStatement` | `visitForStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$ForStmtAltContext ctx)`
    `` | `public Expression` | `visitForUpdate(org.apache.groovy.parser.antlr4.GroovyParser$ForUpdateContext ctx)`
    `` | `public Parameter` | `visitFormalParameter(org.apache.groovy.parser.antlr4.GroovyParser$FormalParameterContext ctx)`
    `` | `public Parameter[]` | `visitFormalParameterList(org.apache.groovy.parser.antlr4.GroovyParser$FormalParameterListContext ctx)`
    `` | `public Parameter[]` | `visitFormalParameters(org.apache.groovy.parser.antlr4.GroovyParser$FormalParametersContext ctx)`
    `` | `public GStringExpression` | `visitGstring(org.apache.groovy.parser.antlr4.GroovyParser$GstringContext ctx)`
    `` | `public Expression` | `visitGstringPath(org.apache.groovy.parser.antlr4.GroovyParser$GstringPathContext ctx)`
    `` | `public Expression` | `visitGstringValue(org.apache.groovy.parser.antlr4.GroovyParser$GstringValueContext ctx)`
    `` | `public String` | `visitIdentifier(org.apache.groovy.parser.antlr4.GroovyParser$IdentifierContext ctx)`
    `` | `public Expression` | `visitIdentifierPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$IdentifierPrmrAltContext ctx)`
    `` | `public IfStatement` | `visitIfElseStatement(org.apache.groovy.parser.antlr4.GroovyParser$IfElseStatementContext ctx)`
    `` | `public ImportNode` | `visitImportDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$ImportDeclarationContext ctx)`
    `` | `public BinaryExpression` | `visitInclusiveOrExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$InclusiveOrExprAltContext ctx)`
    `` | `public Tuple2<Token, Expression>` | `visitIndexPropertyArgs(org.apache.groovy.parser.antlr4.GroovyParser$IndexPropertyArgsContext ctx)`
    `` | `public ConstantExpression` | `visitIntegerLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser$IntegerLiteralAltContext ctx)`
    `` | `public ConstantExpression` | `visitKeywords(org.apache.groovy.parser.antlr4.GroovyParser$KeywordsContext ctx)`
    `` | `public Statement` | `visitLabeledStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$LabeledStmtAltContext ctx)`
    `` | `public Statement` | `visitLambdaBody(org.apache.groovy.parser.antlr4.GroovyParser$LambdaBodyContext ctx)`
    `` | `public ListExpression` | `visitList(org.apache.groovy.parser.antlr4.GroovyParser$ListContext ctx)`
    `` | `public AstBuilder.DeclarationListStatement` | `visitLocalVariableDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$LocalVariableDeclarationContext ctx)`
    `` | `public BinaryExpression` | `visitLogicalAndExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$LogicalAndExprAltContext ctx)`
    `` | `public BinaryExpression` | `visitLogicalOrExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$LogicalOrExprAltContext ctx)`
    `` | `public Statement` | `visitLoopStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$LoopStmtAltContext ctx)`
    `` | `public MapExpression` | `visitMap(org.apache.groovy.parser.antlr4.GroovyParser$MapContext ctx)`
    `` | `public MapEntryExpression` | `visitMapEntry(org.apache.groovy.parser.antlr4.GroovyParser$MapEntryContext ctx)`
    `` | `public Expression` | `visitMapEntryLabel(org.apache.groovy.parser.antlr4.GroovyParser$MapEntryLabelContext ctx)`
    `` | `public List<MapEntryExpression>` | `visitMapEntryList(org.apache.groovy.parser.antlr4.GroovyParser$MapEntryListContext ctx)`
    `` | `public Void` | `visitMemberDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$MemberDeclarationContext ctx)`
    `` | `public Statement` | `visitMethodBody(org.apache.groovy.parser.antlr4.GroovyParser$MethodBodyContext ctx)`
    `` | `public MethodNode` | `visitMethodDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$MethodDeclarationContext ctx)`
    `` | `public String` | `visitMethodName(org.apache.groovy.parser.antlr4.GroovyParser$MethodNameContext ctx)`
    `` | `public ModifierNode` | `visitModifier(org.apache.groovy.parser.antlr4.GroovyParser$ModifierContext ctx)`
    `` | `public List<ModifierNode>` | `visitModifiers(org.apache.groovy.parser.antlr4.GroovyParser$ModifiersContext ctx)`
    `` | `public List<ModifierNode>` | `visitModifiersOpt(org.apache.groovy.parser.antlr4.GroovyParser$ModifiersOptContext ctx)`
    `` | `public BinaryExpression` | `visitMultipleAssignmentExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$MultipleAssignmentExprAltContext ctx)`
    `` | `public BinaryExpression` | `visitMultiplicativeExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$MultiplicativeExprAltContext ctx)`
    `` | `public Expression` | `visitNamePart(org.apache.groovy.parser.antlr4.GroovyParser$NamePartContext ctx)`
    `` | `public List<MapEntryExpression>` | `visitNamedPropertyArgs(org.apache.groovy.parser.antlr4.GroovyParser$NamedPropertyArgsContext ctx)`
    `` | `public Expression` | `visitNewPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$NewPrmrAltContext ctx)`
    `` | `public GenericsType[]` | `visitNonWildcardTypeArguments(org.apache.groovy.parser.antlr4.GroovyParser$NonWildcardTypeArgumentsContext ctx)`
    `` | `public ConstantExpression` | `visitNullLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser$NullLiteralAltContext ctx)`
    `` | `public PackageNode` | `visitPackageDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$PackageDeclarationContext ctx)`
    `` | `public Expression` | `visitParExpression(org.apache.groovy.parser.antlr4.GroovyParser$ParExpressionContext ctx)`
    `` | `public Expression` | `visitPathElement(org.apache.groovy.parser.antlr4.GroovyParser$PathElementContext ctx)`
    `` | `public Expression` | `visitPathExpression(org.apache.groovy.parser.antlr4.GroovyParser$PathExpressionContext ctx)`
    `` | `public Expression` | `visitPostfixExpression(org.apache.groovy.parser.antlr4.GroovyParser$PostfixExpressionContext ctx)`
    `` | `public BinaryExpression` | `visitPowerExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$PowerExprAltContext ctx)`
    `` | `public ClassNode` | `visitPrimitiveType(org.apache.groovy.parser.antlr4.GroovyParser$PrimitiveTypeContext ctx)`
    `` | `public void` | `visitPropertyExpression(PropertyExpression expression)`
    `` | `public ClassNode` | `visitQualifiedClassName(org.apache.groovy.parser.antlr4.GroovyParser$QualifiedClassNameContext ctx)`
    `` | `public ClassNode[]` | `visitQualifiedClassNameList(org.apache.groovy.parser.antlr4.GroovyParser$QualifiedClassNameListContext ctx)`
    `` | `public String` | `visitQualifiedName(org.apache.groovy.parser.antlr4.GroovyParser$QualifiedNameContext ctx)`
    `` | `public ClassNode` | `visitQualifiedStandardClassName(org.apache.groovy.parser.antlr4.GroovyParser$QualifiedStandardClassNameContext ctx)`
    `` | `public BinaryExpression` | `visitRegexExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$RegexExprAltContext ctx)`
    `` | `public Expression` | `visitRelationalExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$RelationalExprAltContext ctx)`
    `` | `public ExpressionStatement` | `visitResource(org.apache.groovy.parser.antlr4.GroovyParser$ResourceContext ctx)`
    `` | `public List<ExpressionStatement>` | `visitResourceList(org.apache.groovy.parser.antlr4.GroovyParser$ResourceListContext ctx)`
    `` | `public List<ExpressionStatement>` | `visitResources(org.apache.groovy.parser.antlr4.GroovyParser$ResourcesContext ctx)`
    `` | `public void` | `visitReturnStatement(ReturnStatement statement)`
    `` | `public ReturnStatement` | `visitReturnStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$ReturnStmtAltContext ctx)`
    `` | `public ClassNode` | `visitReturnType(org.apache.groovy.parser.antlr4.GroovyParser$ReturnTypeContext ctx)`
    `` | `public List<ASTNode>` | `visitScriptStatements(org.apache.groovy.parser.antlr4.GroovyParser$ScriptStatementsContext ctx)`
    `` | `public Expression` | `visitShiftExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$ShiftExprAltContext ctx)`
    `` | `public LambdaExpression` | `visitStandardLambdaExpression(org.apache.groovy.parser.antlr4.GroovyParser$StandardLambdaExpressionContext ctx)`
    `` | `public Parameter[]` | `visitStandardLambdaParameters(org.apache.groovy.parser.antlr4.GroovyParser$StandardLambdaParametersContext ctx)`
    `` | `public ConstantExpression` | `visitStringLiteral(org.apache.groovy.parser.antlr4.GroovyParser$StringLiteralContext ctx)`
    `` | `public VariableExpression` | `visitSuperPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$SuperPrmrAltContext ctx)`
    `` | `public Tuple3<List<Statement>, Boolean, Boolean>` | `visitSwitchBlockStatementExpressionGroup(SwitchBlockStatementExpressionGroupContext ctx)`
    `` | `public List<Statement>` | `visitSwitchBlockStatementGroup(org.apache.groovy.parser.antlr4.GroovyParser$SwitchBlockStatementGroupContext ctx)`
    `` | `public Expression` | `visitSwitchExprAlt(SwitchExprAltContext ctx)`
    `` | `public MethodCallExpression` | `visitSwitchExpression(SwitchExpressionContext ctx)`
         switch(a) {
             case 0, 1  ->   'a';
             case 2     ->   'b';
             default    ->   'z';
         }
    the above code will be transformed to:
         {->
             switch(a) {
                 case 0:
                 case 1:  return 'a';
                 case 2:  return 'b';
                 default: return 'z';
             }
         }()
    `` | `public Tuple3<Token, List<Expression>, Integer>` | `visitSwitchExpressionLabel(SwitchExpressionLabelContext ctx)`
    `` | `public Tuple2<Token, Expression>` | `visitSwitchLabel(org.apache.groovy.parser.antlr4.GroovyParser$SwitchLabelContext ctx)`
    `` | `public SwitchStatement` | `visitSwitchStatement(org.apache.groovy.parser.antlr4.GroovyParser$SwitchStatementContext ctx)`
    `` | `public SynchronizedStatement` | `visitSynchronizedStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$SynchronizedStmtAltContext ctx)`
    `` | `public Parameter` | `visitThisFormalParameter(org.apache.groovy.parser.antlr4.GroovyParser$ThisFormalParameterContext ctx)`
    `` | `public VariableExpression` | `visitThisPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$ThisPrmrAltContext ctx)`
    `` | `public void` | `visitThrowStatement(ThrowStatement statement)`
    `` | `public ThrowStatement` | `visitThrowStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$ThrowStmtAltContext ctx)`
    `` | `public Statement` | `visitTryCatchStatement(org.apache.groovy.parser.antlr4.GroovyParser$TryCatchStatementContext ctx)`
    `` | `public ClassNode` | `visitType(org.apache.groovy.parser.antlr4.GroovyParser$TypeContext ctx)`
    `` | `public GenericsType` | `visitTypeArgument(org.apache.groovy.parser.antlr4.GroovyParser$TypeArgumentContext ctx)`
    `` | `public GenericsType[]` | `visitTypeArguments(org.apache.groovy.parser.antlr4.GroovyParser$TypeArgumentsContext ctx)`
    `` | `public GenericsType[]` | `visitTypeArgumentsOrDiamond(org.apache.groovy.parser.antlr4.GroovyParser$TypeArgumentsOrDiamondContext ctx)`
    `` | `public ClassNode[]` | `visitTypeBound(org.apache.groovy.parser.antlr4.GroovyParser$TypeBoundContext ctx)`
    `` | `public ClassNode` | `visitTypeDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$TypeDeclarationContext ctx)`
    `` | `public ClassNode[]` | `visitTypeList(org.apache.groovy.parser.antlr4.GroovyParser$TypeListContext ctx)`
    `` | `public VariableExpression` | `visitTypeNamePair(org.apache.groovy.parser.antlr4.GroovyParser$TypeNamePairContext ctx)`
    `` | `public List<Expression>` | `visitTypeNamePairs(org.apache.groovy.parser.antlr4.GroovyParser$TypeNamePairsContext ctx)`
    `` | `public GenericsType` | `visitTypeParameter(org.apache.groovy.parser.antlr4.GroovyParser$TypeParameterContext ctx)`
    `` | `public GenericsType[]` | `visitTypeParameters(org.apache.groovy.parser.antlr4.GroovyParser$TypeParametersContext ctx)`
    `` | `public Expression` | `visitUnaryAddExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$UnaryAddExprAltContext ctx)`
    `` | `public Expression` | `visitUnaryNotExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$UnaryNotExprAltContext ctx)`
    `` | `public AstBuilder.DeclarationListStatement` | `visitVariableDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$VariableDeclarationContext ctx)`
    `` | `public DeclarationExpression` | `visitVariableDeclarator(org.apache.groovy.parser.antlr4.GroovyParser$VariableDeclaratorContext ctx)`
    `` | `public VariableExpression` | `visitVariableDeclaratorId(org.apache.groovy.parser.antlr4.GroovyParser$VariableDeclaratorIdContext ctx)`
    `` | `public List<DeclarationExpression>` | `visitVariableDeclarators(org.apache.groovy.parser.antlr4.GroovyParser$VariableDeclaratorsContext ctx)`
    `` | `public Expression` | `visitVariableInitializer(org.apache.groovy.parser.antlr4.GroovyParser$VariableInitializerContext ctx)`
    `` | `public List<Expression>` | `visitVariableInitializers(org.apache.groovy.parser.antlr4.GroovyParser$VariableInitializersContext ctx)`
    `` | `public ModifierNode` | `visitVariableModifier(org.apache.groovy.parser.antlr4.GroovyParser$VariableModifierContext ctx)`
    `` | `public List<ModifierNode>` | `visitVariableModifiers(org.apache.groovy.parser.antlr4.GroovyParser$VariableModifiersContext ctx)`
    `` | `public List<ModifierNode>` | `visitVariableModifiersOpt(org.apache.groovy.parser.antlr4.GroovyParser$VariableModifiersOptContext ctx)`
    `` | `public TupleExpression` | `visitVariableNames(org.apache.groovy.parser.antlr4.GroovyParser$VariableNamesContext ctx)`
    `` | `public WhileStatement` | `visitWhileStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$WhileStmtAltContext ctx)`
    `` | `public ReturnStatement` | `visitYieldStatement(YieldStatementContext ctx)`
    `` | `public ReturnStatement` | `visitYieldStmtAlt(YieldStmtAltContext ctx)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor` | `org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitAnnotation(org.apache.groovy.parser.antlr4.GroovyParser$AnnotationContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitStatement(org.apache.groovy.parser.antlr4.GroovyParser$StatementContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitPostfixExpression(org.apache.groovy.parser.antlr4.GroovyParser$PostfixExpressionContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitBlockStatement(org.apache.groovy.parser.antlr4.GroovyParser$BlockStatementContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitAssertStatement(org.apache.groovy.parser.antlr4.GroovyParser$AssertStatementContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitContinueStatement(org.apache.groovy.parser.antlr4.GroovyParser$ContinueStatementContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitBreakStatement(org.apache.groovy.parser.antlr4.GroovyParser$BreakStatementContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitType(org.apache.groovy.parser.antlr4.GroovyParser$TypeContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitBlock(org.apache.groovy.parser.antlr4.GroovyParser$BlockContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitModifiers(org.apache.groovy.parser.antlr4.GroovyParser$ModifiersContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitPrimitiveType(org.apache.groovy.parser.antlr4.GroovyParser$PrimitiveTypeContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitLiteral(org.apache.groovy.parser.antlr4.GroovyParser$LiteralContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitIdentifier(org.apache.groovy.parser.antlr4.GroovyParser$IdentifierContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitTypeParameter(org.apache.groovy.parser.antlr4.GroovyParser$TypeParameterContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitReturnType(org.apache.groovy.parser.antlr4.GroovyParser$ReturnTypeContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitTypeArgument(org.apache.groovy.parser.antlr4.GroovyParser$TypeArgumentContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitCompilationUnit(org.apache.groovy.parser.antlr4.GroovyParser$CompilationUnitContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitSwitchExpression(org.apache.groovy.parser.antlr4.GroovyParser$SwitchExpressionContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitQualifiedName(org.apache.groovy.parser.antlr4.GroovyParser$QualifiedNameContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitForControl(org.apache.groovy.parser.antlr4.GroovyParser$ForControlContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitGstringPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$GstringPrmrAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitExpressionStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$ExpressionStmtAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitContinueStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$ContinueStmtAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitQualifiedNameElement(org.apache.groovy.parser.antlr4.GroovyParser$QualifiedNameElementContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitElementValuePairName(org.apache.groovy.parser.antlr4.GroovyParser$ElementValuePairNameContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitQualifiedNameElements(org.apache.groovy.parser.antlr4.GroovyParser$QualifiedNameElementsContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitStringLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser$StringLiteralAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitLiteralPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$LiteralPrmrAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitBuiltInTypePrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$BuiltInTypePrmrAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitPostfixExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$PostfixExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitConditionalStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$ConditionalStmtAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitTryCatchStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$TryCatchStmtAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitScriptStatement(org.apache.groovy.parser.antlr4.GroovyParser$ScriptStatementContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitStatementExpression(org.apache.groovy.parser.antlr4.GroovyParser$StatementExpressionContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitScriptStatements(org.apache.groovy.parser.antlr4.GroovyParser$ScriptStatementsContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitIfElseStatement(org.apache.groovy.parser.antlr4.GroovyParser$IfElseStatementContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitLocalVariableDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$LocalVariableDeclarationContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitAnnotationsOpt(org.apache.groovy.parser.antlr4.GroovyParser$AnnotationsOptContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitClassOrInterfaceModifiersOpt(org.apache.groovy.parser.antlr4.GroovyParser$ClassOrInterfaceModifiersOptContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitEnhancedForControl(org.apache.groovy.parser.antlr4.GroovyParser$EnhancedForControlContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitExpressionList(org.apache.groovy.parser.antlr4.GroovyParser$ExpressionListContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitFormalParameters(org.apache.groovy.parser.antlr4.GroovyParser$FormalParametersContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitMemberDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$MemberDeclarationContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitYieldStatement(org.apache.groovy.parser.antlr4.GroovyParser$YieldStatementContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitVariableDeclaratorId(org.apache.groovy.parser.antlr4.GroovyParser$VariableDeclaratorIdContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitTypeParameters(org.apache.groovy.parser.antlr4.GroovyParser$TypeParametersContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitClassDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$ClassDeclarationContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitExpressionInPar(org.apache.groovy.parser.antlr4.GroovyParser$ExpressionInParContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitSwitchStatement(org.apache.groovy.parser.antlr4.GroovyParser$SwitchStatementContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitClassicalForControl(org.apache.groovy.parser.antlr4.GroovyParser$ClassicalForControlContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitVariableInitializers(org.apache.groovy.parser.antlr4.GroovyParser$VariableInitializersContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitStandardLambdaExpression(org.apache.groovy.parser.antlr4.GroovyParser$StandardLambdaExpressionContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitQualifiedClassNameList(org.apache.groovy.parser.antlr4.GroovyParser$QualifiedClassNameListContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitEnhancedStatementExpression(org.apache.groovy.parser.antlr4.GroovyParser$EnhancedStatementExpressionContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitEnhancedArgumentListInPar(org.apache.groovy.parser.antlr4.GroovyParser$EnhancedArgumentListInParContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitNonWildcardTypeArguments(org.apache.groovy.parser.antlr4.GroovyParser$NonWildcardTypeArgumentsContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitVariableInitializer(org.apache.groovy.parser.antlr4.GroovyParser$VariableInitializerContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitFieldDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$FieldDeclarationContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitCompactConstructorDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$CompactConstructorDeclarationContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitVariableDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$VariableDeclarationContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitCommandExpression(org.apache.groovy.parser.antlr4.GroovyParser$CommandExpressionContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitVariableDeclarators(org.apache.groovy.parser.antlr4.GroovyParser$VariableDeclaratorsContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitMethodDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$MethodDeclarationContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitBlockStatementsOpt(org.apache.groovy.parser.antlr4.GroovyParser$BlockStatementsOptContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitExpressionListElement(org.apache.groovy.parser.antlr4.GroovyParser$ExpressionListElementContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitCastParExpression(org.apache.groovy.parser.antlr4.GroovyParser$CastParExpressionContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitStandardLambdaParameters(org.apache.groovy.parser.antlr4.GroovyParser$StandardLambdaParametersContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitNamedPropertyArgs(org.apache.groovy.parser.antlr4.GroovyParser$NamedPropertyArgsContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitPathExpression(org.apache.groovy.parser.antlr4.GroovyParser$PathExpressionContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitArrayInitializer(org.apache.groovy.parser.antlr4.GroovyParser$ArrayInitializerContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitTypeArgumentsOrDiamond(org.apache.groovy.parser.antlr4.GroovyParser$TypeArgumentsOrDiamondContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitQualifiedClassName(org.apache.groovy.parser.antlr4.GroovyParser$QualifiedClassNameContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitClosureOrLambdaExpression(org.apache.groovy.parser.antlr4.GroovyParser$ClosureOrLambdaExpressionContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitIndexPropertyArgs(org.apache.groovy.parser.antlr4.GroovyParser$IndexPropertyArgsContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitFormalParameterList(org.apache.groovy.parser.antlr4.GroovyParser$FormalParameterListContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitThisFormalParameter(org.apache.groovy.parser.antlr4.GroovyParser$ThisFormalParameterContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitDynamicMemberName(org.apache.groovy.parser.antlr4.GroovyParser$DynamicMemberNameContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitConditionalStatement(org.apache.groovy.parser.antlr4.GroovyParser$ConditionalStatementContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitVariableModifiers(org.apache.groovy.parser.antlr4.GroovyParser$VariableModifiersContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitCommandExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$CommandExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitInclusiveOrExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$InclusiveOrExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitVariableModifiersOpt(org.apache.groovy.parser.antlr4.GroovyParser$VariableModifiersOptContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitLabeledStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$LabeledStmtAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitExclusiveOrExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$ExclusiveOrExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitElementValueArrayInitializer(org.apache.groovy.parser.antlr4.GroovyParser$ElementValueArrayInitializerContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitSynchronizedStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$SynchronizedStmtAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitEqualityExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$EqualityExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitVariableDeclarator(org.apache.groovy.parser.antlr4.GroovyParser$VariableDeclaratorContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitRelationalExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$RelationalExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitTryCatchStatement(org.apache.groovy.parser.antlr4.GroovyParser$TryCatchStatementContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitAssignmentExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$AssignmentExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitAdditiveExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$AdditiveExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitBlockStatements(org.apache.groovy.parser.antlr4.GroovyParser$BlockStatementsContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitSwitchExpressionLabel(org.apache.groovy.parser.antlr4.GroovyParser$SwitchExpressionLabelContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitClassOrInterfaceModifiers(org.apache.groovy.parser.antlr4.GroovyParser$ClassOrInterfaceModifiersContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitClassOrInterfaceModifier(org.apache.groovy.parser.antlr4.GroovyParser$ClassOrInterfaceModifierContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitElementValuePairs(org.apache.groovy.parser.antlr4.GroovyParser$ElementValuePairsContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitEnhancedArgumentListElement(org.apache.groovy.parser.antlr4.GroovyParser$EnhancedArgumentListElementContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitSwitchBlockStatementGroup(org.apache.groovy.parser.antlr4.GroovyParser$SwitchBlockStatementGroupContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitElementValuePair(org.apache.groovy.parser.antlr4.GroovyParser$ElementValuePairContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitClassBodyDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$ClassBodyDeclarationContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitImportDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$ImportDeclarationContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitFormalParameter(org.apache.groovy.parser.antlr4.GroovyParser$FormalParameterContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitPackageDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$PackageDeclarationContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitMultipleAssignmentExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$MultipleAssignmentExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitConditionalExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$ConditionalExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitAnnotatedQualifiedClassName(org.apache.groovy.parser.antlr4.GroovyParser$AnnotatedQualifiedClassNameContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitVariableModifier(org.apache.groovy.parser.antlr4.GroovyParser$VariableModifierContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitLogicalOrExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$LogicalOrExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitTypeDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$TypeDeclarationContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitLogicalAndExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$LogicalAndExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitAnnotationName(org.apache.groovy.parser.antlr4.GroovyParser$AnnotationNameContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitQualifiedStandardClassName(org.apache.groovy.parser.antlr4.GroovyParser$QualifiedStandardClassNameContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitCommandArgument(org.apache.groovy.parser.antlr4.GroovyParser$CommandArgumentContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitDoWhileStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$DoWhileStmtAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitClassOrInterfaceType(org.apache.groovy.parser.antlr4.GroovyParser$ClassOrInterfaceTypeContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitNullLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser$NullLiteralAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitUnaryAddExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$UnaryAddExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitUnaryNotExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$UnaryNotExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitBooleanLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser$BooleanLiteralAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitIdentifierPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$IdentifierPrmrAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitFloatingPointLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser$FloatingPointLiteralAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitMultiplicativeExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$MultiplicativeExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitIntegerLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser$IntegerLiteralAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitParenPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$ParenPrmrAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitMapPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$MapPrmrAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitListPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$ListPrmrAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitAssertStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$AssertStmtAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitBreakStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$BreakStmtAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitEmptyStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$EmptyStmtAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitBlockStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$BlockStmtAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitLoopStatement(org.apache.groovy.parser.antlr4.GroovyParser$LoopStatementContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitPrimary(org.apache.groovy.parser.antlr4.GroovyParser$PrimaryContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitRparen(org.apache.groovy.parser.antlr4.GroovyParser$RparenContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitExpression(org.apache.groovy.parser.antlr4.GroovyParser$ExpressionContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitNls(org.apache.groovy.parser.antlr4.GroovyParser$NlsContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitSep(org.apache.groovy.parser.antlr4.GroovyParser$SepContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitEnumConstant(org.apache.groovy.parser.antlr4.GroovyParser$EnumConstantContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitCatchType(org.apache.groovy.parser.antlr4.GroovyParser$CatchTypeContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitResourceList(org.apache.groovy.parser.antlr4.GroovyParser$ResourceListContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitForUpdate(org.apache.groovy.parser.antlr4.GroovyParser$ForUpdateContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitFinallyBlock(org.apache.groovy.parser.antlr4.GroovyParser$FinallyBlockContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitResources(org.apache.groovy.parser.antlr4.GroovyParser$ResourcesContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitForInit(org.apache.groovy.parser.antlr4.GroovyParser$ForInitContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitTypeList(org.apache.groovy.parser.antlr4.GroovyParser$TypeListContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitEnumConstants(org.apache.groovy.parser.antlr4.GroovyParser$EnumConstantsContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitClassBody(org.apache.groovy.parser.antlr4.GroovyParser$ClassBodyContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitClassName(org.apache.groovy.parser.antlr4.GroovyParser$ClassNameContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitTypeBound(org.apache.groovy.parser.antlr4.GroovyParser$TypeBoundContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitModifiersOpt(org.apache.groovy.parser.antlr4.GroovyParser$ModifiersOptContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitMethodName(org.apache.groovy.parser.antlr4.GroovyParser$MethodNameContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitArguments(org.apache.groovy.parser.antlr4.GroovyParser$ArgumentsContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitMethodBody(org.apache.groovy.parser.antlr4.GroovyParser$MethodBodyContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitElementValue(org.apache.groovy.parser.antlr4.GroovyParser$ElementValueContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitStringLiteral(org.apache.groovy.parser.antlr4.GroovyParser$StringLiteralContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitTypeNamePairs(org.apache.groovy.parser.antlr4.GroovyParser$TypeNamePairsContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitCreator(org.apache.groovy.parser.antlr4.GroovyParser$CreatorContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitNamePart(org.apache.groovy.parser.antlr4.GroovyParser$NamePartContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitParExpression(org.apache.groovy.parser.antlr4.GroovyParser$ParExpressionContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitMapEntryList(org.apache.groovy.parser.antlr4.GroovyParser$MapEntryListContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitMapEntry(org.apache.groovy.parser.antlr4.GroovyParser$MapEntryContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitGstring(org.apache.groovy.parser.antlr4.GroovyParser$GstringContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitVariableNames(org.apache.groovy.parser.antlr4.GroovyParser$VariableNamesContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitTypeArguments(org.apache.groovy.parser.antlr4.GroovyParser$TypeArgumentsContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitCreatedName(org.apache.groovy.parser.antlr4.GroovyParser$CreatedNameContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitMapEntryLabel(org.apache.groovy.parser.antlr4.GroovyParser$MapEntryLabelContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitClosure(org.apache.groovy.parser.antlr4.GroovyParser$ClosureContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitGstringPath(org.apache.groovy.parser.antlr4.GroovyParser$GstringPathContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitKeywords(org.apache.groovy.parser.antlr4.GroovyParser$KeywordsContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitLambdaBody(org.apache.groovy.parser.antlr4.GroovyParser$LambdaBodyContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitEmptyDims(org.apache.groovy.parser.antlr4.GroovyParser$EmptyDimsContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitEmptyDimsOpt(org.apache.groovy.parser.antlr4.GroovyParser$EmptyDimsOptContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitElementValues(org.apache.groovy.parser.antlr4.GroovyParser$ElementValuesContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitList(org.apache.groovy.parser.antlr4.GroovyParser$ListContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitResource(org.apache.groovy.parser.antlr4.GroovyParser$ResourceContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitSwitchLabel(org.apache.groovy.parser.antlr4.GroovyParser$SwitchLabelContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitTypeNamePair(org.apache.groovy.parser.antlr4.GroovyParser$TypeNamePairContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitDim(org.apache.groovy.parser.antlr4.GroovyParser$DimContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitPathElement(org.apache.groovy.parser.antlr4.GroovyParser$PathElementContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitCatchClause(org.apache.groovy.parser.antlr4.GroovyParser$CatchClauseContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitGstringValue(org.apache.groovy.parser.antlr4.GroovyParser$GstringValueContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitMap(org.apache.groovy.parser.antlr4.GroovyParser$MapContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitBuiltInType(org.apache.groovy.parser.antlr4.GroovyParser$BuiltInTypeContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitRegexExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$RegexExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitReturnStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$ReturnStmtAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitWhileStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$WhileStmtAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitThrowStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$ThrowStmtAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitModifier(org.apache.groovy.parser.antlr4.GroovyParser$ModifierContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitForStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$ForStmtAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitYieldStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$YieldStmtAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitAndExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$AndExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitLoopStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$LoopStmtAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitCastExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$CastExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitNewPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$NewPrmrAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitThisPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$ThisPrmrAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitSwitchExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$SwitchExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitPowerExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$PowerExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitShiftExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$ShiftExprAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitSuperPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$SuperPrmrAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitAnonymousInnerClassDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$AnonymousInnerClassDeclarationContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitSwitchBlockStatementExpressionGroup(org.apache.groovy.parser.antlr4.GroovyParser$SwitchBlockStatementExpressionGroupContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitLocalVariableDeclarationStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$LocalVariableDeclarationStmtAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitClosureOrLambdaExpressionPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$ClosureOrLambdaExpressionPrmrAltContext), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visit(org.antlr.v4.runtime.tree.ParseTree), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitChildren(org.antlr.v4.runtime.tree.RuleNode), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitTerminal(org.antlr.v4.runtime.tree.TerminalNode), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#visitErrorNode(org.antlr.v4.runtime.tree.ErrorNode), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#wait(long, int), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#wait(), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#wait(long), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#equals(java.lang.Object), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#toString(), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#hashCode(), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#getClass(), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#notify(), org.apache.groovy.parser.antlr4.GroovyParserBaseVisitor#notifyAll()`

- - ### Constructor Detail

    - #### public AstBuilder(SourceUnit sourceUnit, boolean groovydocEnabled, boolean runtimeGroovydocEnabled)

  - ### Method Detail

    - #### public BlockStatement appendStatementsToBlockStatement(BlockStatement bs, Statement statements)

    - #### public ModuleNode buildAST()

    - #### @Override public void syntaxError(Recognizer recognizer, Object offendingSymbol, int line, int charPositionInLine, String msg, RecognitionException e)

    - #### @Override public Object visit(ParseTree tree)

      Visit tree safely, no NPE occurred when the tree is null.

      Parameters:
        `tree` - an AST node
      Returns:
        the visiting result

    - #### @Override public BinaryExpression visitAdditiveExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$AdditiveExprAltContext ctx)

    - #### @Override public BinaryExpression visitAndExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$AndExprAltContext ctx)

    - #### @Override public ClassNode visitAnnotatedQualifiedClassName(org.apache.groovy.parser.antlr4.GroovyParser$AnnotatedQualifiedClassNameContext ctx)

    - #### @Override public AnnotationNode visitAnnotation(org.apache.groovy.parser.antlr4.GroovyParser$AnnotationContext ctx)

    - #### @Override public String visitAnnotationName(org.apache.groovy.parser.antlr4.GroovyParser$AnnotationNameContext ctx)

    - #### @Override public List<AnnotationNode> visitAnnotationsOpt(org.apache.groovy.parser.antlr4.GroovyParser$AnnotationsOptContext ctx)

    - #### @Override public InnerClassNode visitAnonymousInnerClassDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$AnonymousInnerClassDeclarationContext ctx)

    - #### @Override public Expression visitArguments(org.apache.groovy.parser.antlr4.GroovyParser$ArgumentsContext ctx)

    - #### @Override public List<Expression> visitArrayInitializer(org.apache.groovy.parser.antlr4.GroovyParser$ArrayInitializerContext ctx)

    - #### @Override public AssertStatement visitAssertStatement(org.apache.groovy.parser.antlr4.GroovyParser$AssertStatementContext ctx)

    - #### @Override public BinaryExpression visitAssignmentExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$AssignmentExprAltContext ctx)

    - #### @Override public Statement visitBlock(org.apache.groovy.parser.antlr4.GroovyParser$BlockContext ctx)

    - #### @Override public Statement visitBlockStatement(org.apache.groovy.parser.antlr4.GroovyParser$BlockStatementContext ctx)

    - #### @Override public BlockStatement visitBlockStatements(org.apache.groovy.parser.antlr4.GroovyParser$BlockStatementsContext ctx)

    - #### @Override public BlockStatement visitBlockStatementsOpt(org.apache.groovy.parser.antlr4.GroovyParser$BlockStatementsOptContext ctx)

    - #### @Override public ConstantExpression visitBooleanLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser$BooleanLiteralAltContext ctx)

    - #### @Override public BreakStatement visitBreakStatement(org.apache.groovy.parser.antlr4.GroovyParser$BreakStatementContext ctx)

    - #### @Override public VariableExpression visitBuiltInType(org.apache.groovy.parser.antlr4.GroovyParser$BuiltInTypeContext ctx)

    - #### @Override public CastExpression visitCastExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$CastExprAltContext ctx)

    - #### @Override public ClassNode visitCastParExpression(org.apache.groovy.parser.antlr4.GroovyParser$CastParExpressionContext ctx)

    - #### @Override public List<CatchStatement> visitCatchClause(org.apache.groovy.parser.antlr4.GroovyParser$CatchClauseContext ctx)

      Multi-catch(1..*) clause will be unpacked to several normal catch clauses, so the return type is List

      Parameters:
        `ctx` - the parse tree
      Returns:
        a list of CatchStatement instances

    - #### @Override public List<ClassNode> visitCatchType(org.apache.groovy.parser.antlr4.GroovyParser$CatchTypeContext ctx)

    - #### @Override public Void visitClassBody(org.apache.groovy.parser.antlr4.GroovyParser$ClassBodyContext ctx)

    - #### @Override public Void visitClassBodyDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$ClassBodyDeclarationContext ctx)

    - #### @Override public ClassNode visitClassDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$ClassDeclarationContext ctx)

    - #### @Override public String visitClassName(org.apache.groovy.parser.antlr4.GroovyParser$ClassNameContext ctx)

    - #### @Override public ModifierNode visitClassOrInterfaceModifier(org.apache.groovy.parser.antlr4.GroovyParser$ClassOrInterfaceModifierContext ctx)

    - #### @Override public List<ModifierNode> visitClassOrInterfaceModifiers(org.apache.groovy.parser.antlr4.GroovyParser$ClassOrInterfaceModifiersContext ctx)

    - #### @Override public List<ModifierNode> visitClassOrInterfaceModifiersOpt(org.apache.groovy.parser.antlr4.GroovyParser$ClassOrInterfaceModifiersOptContext ctx)

    - #### @Override public ClassNode visitClassOrInterfaceType(org.apache.groovy.parser.antlr4.GroovyParser$ClassOrInterfaceTypeContext ctx)

    - #### @Override public Tuple2<Parameter, Expression> visitClassicalForControl(org.apache.groovy.parser.antlr4.GroovyParser$ClassicalForControlContext ctx)

    - #### @Override public ClosureExpression visitClosure(org.apache.groovy.parser.antlr4.GroovyParser$ClosureContext ctx)

    - #### @Override public ClosureExpression visitClosureOrLambdaExpression(org.apache.groovy.parser.antlr4.GroovyParser$ClosureOrLambdaExpressionContext ctx)

    - #### @Override public Expression visitCommandArgument(org.apache.groovy.parser.antlr4.GroovyParser$CommandArgumentContext ctx)

    - #### @Override public ExpressionStatement visitCommandExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$CommandExprAltContext ctx)

    - #### @Override public Expression visitCommandExpression(org.apache.groovy.parser.antlr4.GroovyParser$CommandExpressionContext ctx)

    - #### @Override public MethodNode visitCompactConstructorDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$CompactConstructorDeclarationContext ctx)

    - #### @Override public ModuleNode visitCompilationUnit(org.apache.groovy.parser.antlr4.GroovyParser$CompilationUnitContext ctx)

    - #### @Override public Expression visitConditionalExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$ConditionalExprAltContext ctx)

    - #### @Override public Statement visitConditionalStatement(org.apache.groovy.parser.antlr4.GroovyParser$ConditionalStatementContext ctx)

    - #### @Override public ContinueStatement visitContinueStatement(org.apache.groovy.parser.antlr4.GroovyParser$ContinueStatementContext ctx)

    - #### @Override public ClassNode visitCreatedName(org.apache.groovy.parser.antlr4.GroovyParser$CreatedNameContext ctx)

    - #### @Override public Expression visitCreator(org.apache.groovy.parser.antlr4.GroovyParser$CreatorContext ctx)

    - #### @Override public Tuple3<Expression, List<AnnotationNode>, TerminalNode> visitDim(org.apache.groovy.parser.antlr4.GroovyParser$DimContext ctx)

    - #### @Override public DoWhileStatement visitDoWhileStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$DoWhileStmtAltContext ctx)

    - #### @Override public Expression visitDynamicMemberName(org.apache.groovy.parser.antlr4.GroovyParser$DynamicMemberNameContext ctx)

    - #### @Override public Expression visitElementValue(org.apache.groovy.parser.antlr4.GroovyParser$ElementValueContext ctx)

    - #### @Override public ListExpression visitElementValueArrayInitializer(org.apache.groovy.parser.antlr4.GroovyParser$ElementValueArrayInitializerContext ctx)

    - #### @Override public Tuple2<String, Expression> visitElementValuePair(org.apache.groovy.parser.antlr4.GroovyParser$ElementValuePairContext ctx)

    - #### @Override public Map<String, Expression> visitElementValuePairs(org.apache.groovy.parser.antlr4.GroovyParser$ElementValuePairsContext ctx)

    - #### @Override public List<Tuple2<String, Expression>> visitElementValues(org.apache.groovy.parser.antlr4.GroovyParser$ElementValuesContext ctx)

    - #### @Override public List<List<AnnotationNode>> visitEmptyDims(org.apache.groovy.parser.antlr4.GroovyParser$EmptyDimsContext ctx)

    - #### @Override public List<List<AnnotationNode>> visitEmptyDimsOpt(org.apache.groovy.parser.antlr4.GroovyParser$EmptyDimsOptContext ctx)

    - #### @Override public Expression visitEnhancedArgumentListElement(org.apache.groovy.parser.antlr4.GroovyParser$EnhancedArgumentListElementContext ctx)

    - #### @Override public Expression visitEnhancedArgumentListInPar(org.apache.groovy.parser.antlr4.GroovyParser$EnhancedArgumentListInParContext ctx)

    - #### @Override public Tuple2<Parameter, Expression> visitEnhancedForControl(org.apache.groovy.parser.antlr4.GroovyParser$EnhancedForControlContext ctx)

    - #### @Override public Expression visitEnhancedStatementExpression(org.apache.groovy.parser.antlr4.GroovyParser$EnhancedStatementExpressionContext ctx)

    - #### @Override public FieldNode visitEnumConstant(org.apache.groovy.parser.antlr4.GroovyParser$EnumConstantContext ctx)

    - #### @Override public List<FieldNode> visitEnumConstants(org.apache.groovy.parser.antlr4.GroovyParser$EnumConstantsContext ctx)

    - #### @Override public BinaryExpression visitEqualityExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$EqualityExprAltContext ctx)

    - #### @Override public BinaryExpression visitExclusiveOrExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$ExclusiveOrExprAltContext ctx)

    - #### @Override public Expression visitExpressionInPar(org.apache.groovy.parser.antlr4.GroovyParser$ExpressionInParContext ctx)

    - #### @Override public List<Expression> visitExpressionList(org.apache.groovy.parser.antlr4.GroovyParser$ExpressionListContext ctx)

    - #### @Override public Expression visitExpressionListElement(org.apache.groovy.parser.antlr4.GroovyParser$ExpressionListElementContext ctx)

    - #### @Override public Void visitFieldDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$FieldDeclarationContext ctx)

    - #### @Override public Statement visitFinallyBlock(org.apache.groovy.parser.antlr4.GroovyParser$FinallyBlockContext ctx)

    - #### @Override public ConstantExpression visitFloatingPointLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser$FloatingPointLiteralAltContext ctx)

    - #### @Override public Tuple2<Parameter, Expression> visitForControl(org.apache.groovy.parser.antlr4.GroovyParser$ForControlContext ctx)

    - #### @Override @SuppressWarnings("unchecked") public Expression visitForInit(org.apache.groovy.parser.antlr4.GroovyParser$ForInitContext ctx)

    - #### @Override public ForStatement visitForStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$ForStmtAltContext ctx)

    - #### @Override public Expression visitForUpdate(org.apache.groovy.parser.antlr4.GroovyParser$ForUpdateContext ctx)

    - #### @Override public Parameter visitFormalParameter(org.apache.groovy.parser.antlr4.GroovyParser$FormalParameterContext ctx)

    - #### @Override public Parameter[] visitFormalParameterList(org.apache.groovy.parser.antlr4.GroovyParser$FormalParameterListContext ctx)

    - #### @Override public Parameter[] visitFormalParameters(org.apache.groovy.parser.antlr4.GroovyParser$FormalParametersContext ctx)

    - #### @Override public GStringExpression visitGstring(org.apache.groovy.parser.antlr4.GroovyParser$GstringContext ctx)

    - #### @Override public Expression visitGstringPath(org.apache.groovy.parser.antlr4.GroovyParser$GstringPathContext ctx)

    - #### @Override public Expression visitGstringValue(org.apache.groovy.parser.antlr4.GroovyParser$GstringValueContext ctx)

    - #### @Override public String visitIdentifier(org.apache.groovy.parser.antlr4.GroovyParser$IdentifierContext ctx)

    - #### @Override public Expression visitIdentifierPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$IdentifierPrmrAltContext ctx)

    - #### @Override public IfStatement visitIfElseStatement(org.apache.groovy.parser.antlr4.GroovyParser$IfElseStatementContext ctx)

    - #### @Override public ImportNode visitImportDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$ImportDeclarationContext ctx)

    - #### @Override public BinaryExpression visitInclusiveOrExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$InclusiveOrExprAltContext ctx)

    - #### @Override public Tuple2<Token, Expression> visitIndexPropertyArgs(org.apache.groovy.parser.antlr4.GroovyParser$IndexPropertyArgsContext ctx)

    - #### @Override public ConstantExpression visitIntegerLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser$IntegerLiteralAltContext ctx)

    - #### @Override public ConstantExpression visitKeywords(org.apache.groovy.parser.antlr4.GroovyParser$KeywordsContext ctx)

    - #### @Override public Statement visitLabeledStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$LabeledStmtAltContext ctx)

    - #### @Override public Statement visitLambdaBody(org.apache.groovy.parser.antlr4.GroovyParser$LambdaBodyContext ctx)

    - #### @Override public ListExpression visitList(org.apache.groovy.parser.antlr4.GroovyParser$ListContext ctx)

    - #### @Override public AstBuilder.DeclarationListStatement visitLocalVariableDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$LocalVariableDeclarationContext ctx)

    - #### @Override public BinaryExpression visitLogicalAndExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$LogicalAndExprAltContext ctx)

    - #### @Override public BinaryExpression visitLogicalOrExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$LogicalOrExprAltContext ctx)

    - #### @Override public Statement visitLoopStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$LoopStmtAltContext ctx)

    - #### @Override public MapExpression visitMap(org.apache.groovy.parser.antlr4.GroovyParser$MapContext ctx)

    - #### @Override public MapEntryExpression visitMapEntry(org.apache.groovy.parser.antlr4.GroovyParser$MapEntryContext ctx)

    - #### @Override public Expression visitMapEntryLabel(org.apache.groovy.parser.antlr4.GroovyParser$MapEntryLabelContext ctx)

    - #### @Override public List<MapEntryExpression> visitMapEntryList(org.apache.groovy.parser.antlr4.GroovyParser$MapEntryListContext ctx)

    - #### @Override public Void visitMemberDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$MemberDeclarationContext ctx)

    - #### @Override public Statement visitMethodBody(org.apache.groovy.parser.antlr4.GroovyParser$MethodBodyContext ctx)

    - #### @Override public MethodNode visitMethodDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$MethodDeclarationContext ctx)

    - #### @Override public String visitMethodName(org.apache.groovy.parser.antlr4.GroovyParser$MethodNameContext ctx)

    - #### @Override public ModifierNode visitModifier(org.apache.groovy.parser.antlr4.GroovyParser$ModifierContext ctx)

    - #### @Override public List<ModifierNode> visitModifiers(org.apache.groovy.parser.antlr4.GroovyParser$ModifiersContext ctx)

    - #### @Override public List<ModifierNode> visitModifiersOpt(org.apache.groovy.parser.antlr4.GroovyParser$ModifiersOptContext ctx)

    - #### @Override public BinaryExpression visitMultipleAssignmentExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$MultipleAssignmentExprAltContext ctx)

    - #### @Override public BinaryExpression visitMultiplicativeExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$MultiplicativeExprAltContext ctx)

    - #### @Override public Expression visitNamePart(org.apache.groovy.parser.antlr4.GroovyParser$NamePartContext ctx)

    - #### @Override public List<MapEntryExpression> visitNamedPropertyArgs(org.apache.groovy.parser.antlr4.GroovyParser$NamedPropertyArgsContext ctx)

    - #### @Override public Expression visitNewPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$NewPrmrAltContext ctx)

    - #### @Override public GenericsType[] visitNonWildcardTypeArguments(org.apache.groovy.parser.antlr4.GroovyParser$NonWildcardTypeArgumentsContext ctx)

    - #### @Override public ConstantExpression visitNullLiteralAlt(org.apache.groovy.parser.antlr4.GroovyParser$NullLiteralAltContext ctx)

    - #### @Override public PackageNode visitPackageDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$PackageDeclarationContext ctx)

    - #### @Override public Expression visitParExpression(org.apache.groovy.parser.antlr4.GroovyParser$ParExpressionContext ctx)

    - #### @Override public Expression visitPathElement(org.apache.groovy.parser.antlr4.GroovyParser$PathElementContext ctx)

    - #### @Override public Expression visitPathExpression(org.apache.groovy.parser.antlr4.GroovyParser$PathExpressionContext ctx)

    - #### @Override public Expression visitPostfixExpression(org.apache.groovy.parser.antlr4.GroovyParser$PostfixExpressionContext ctx)

    - #### @Override public BinaryExpression visitPowerExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$PowerExprAltContext ctx)

    - #### @Override public ClassNode visitPrimitiveType(org.apache.groovy.parser.antlr4.GroovyParser$PrimitiveTypeContext ctx)

    - #### @Override public void visitPropertyExpression(PropertyExpression expression)

    - #### @Override public ClassNode visitQualifiedClassName(org.apache.groovy.parser.antlr4.GroovyParser$QualifiedClassNameContext ctx)

    - #### @Override public ClassNode[] visitQualifiedClassNameList(org.apache.groovy.parser.antlr4.GroovyParser$QualifiedClassNameListContext ctx)

    - #### @Override public String visitQualifiedName(org.apache.groovy.parser.antlr4.GroovyParser$QualifiedNameContext ctx)

    - #### @Override public ClassNode visitQualifiedStandardClassName(org.apache.groovy.parser.antlr4.GroovyParser$QualifiedStandardClassNameContext ctx)

    - #### @Override public BinaryExpression visitRegexExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$RegexExprAltContext ctx)

    - #### @Override public Expression visitRelationalExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$RelationalExprAltContext ctx)

    - #### @Override public ExpressionStatement visitResource(org.apache.groovy.parser.antlr4.GroovyParser$ResourceContext ctx)

    - #### @Override public List<ExpressionStatement> visitResourceList(org.apache.groovy.parser.antlr4.GroovyParser$ResourceListContext ctx)

    - #### @Override public List<ExpressionStatement> visitResources(org.apache.groovy.parser.antlr4.GroovyParser$ResourcesContext ctx)

    - #### @Override public void visitReturnStatement(ReturnStatement statement)

    - #### @Override public ReturnStatement visitReturnStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$ReturnStmtAltContext ctx)

    - #### @Override public ClassNode visitReturnType(org.apache.groovy.parser.antlr4.GroovyParser$ReturnTypeContext ctx)

    - #### @Override public List<ASTNode> visitScriptStatements(org.apache.groovy.parser.antlr4.GroovyParser$ScriptStatementsContext ctx)

    - #### @Override public Expression visitShiftExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$ShiftExprAltContext ctx)

    - #### @Override public LambdaExpression visitStandardLambdaExpression(org.apache.groovy.parser.antlr4.GroovyParser$StandardLambdaExpressionContext ctx)

    - #### @Override public Parameter[] visitStandardLambdaParameters(org.apache.groovy.parser.antlr4.GroovyParser$StandardLambdaParametersContext ctx)

    - #### @Override public ConstantExpression visitStringLiteral(org.apache.groovy.parser.antlr4.GroovyParser$StringLiteralContext ctx)

    - #### @Override public VariableExpression visitSuperPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$SuperPrmrAltContext ctx)

    - #### @Override @SuppressWarnings("unchecked") public Tuple3<List<Statement>, Boolean, Boolean> visitSwitchBlockStatementExpressionGroup(SwitchBlockStatementExpressionGroupContext ctx)

    - #### @Override @SuppressWarnings("unchecked") public List<Statement> visitSwitchBlockStatementGroup(org.apache.groovy.parser.antlr4.GroovyParser$SwitchBlockStatementGroupContext ctx)

    - #### @Override public Expression visitSwitchExprAlt(SwitchExprAltContext ctx)

    - #### @Override public MethodCallExpression visitSwitchExpression(SwitchExpressionContext ctx)

           switch(a) {
               case 0, 1  ->   'a';
               case 2     ->   'b';
               default    ->   'z';
           }

      the above code will be transformed to:

           {->
               switch(a) {
                   case 0:
                   case 1:  return 'a';
                   case 2:  return 'b';
                   default: return 'z';
               }
           }()

      Parameters:
        `ctx` - the parse tree
      Returns:
        MethodCallExpression instance

    - #### @Override public Tuple3<Token, List<Expression>, Integer> visitSwitchExpressionLabel(SwitchExpressionLabelContext ctx)

    - #### @Override public Tuple2<Token, Expression> visitSwitchLabel(org.apache.groovy.parser.antlr4.GroovyParser$SwitchLabelContext ctx)

    - #### @Override public SwitchStatement visitSwitchStatement(org.apache.groovy.parser.antlr4.GroovyParser$SwitchStatementContext ctx)

    - #### @Override public SynchronizedStatement visitSynchronizedStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$SynchronizedStmtAltContext ctx)

    - #### @Override public Parameter visitThisFormalParameter(org.apache.groovy.parser.antlr4.GroovyParser$ThisFormalParameterContext ctx)

    - #### @Override public VariableExpression visitThisPrmrAlt(org.apache.groovy.parser.antlr4.GroovyParser$ThisPrmrAltContext ctx)

    - #### @Override public void visitThrowStatement(ThrowStatement statement)

    - #### @Override public ThrowStatement visitThrowStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$ThrowStmtAltContext ctx)

    - #### @Override public Statement visitTryCatchStatement(org.apache.groovy.parser.antlr4.GroovyParser$TryCatchStatementContext ctx)

    - #### @Override public ClassNode visitType(org.apache.groovy.parser.antlr4.GroovyParser$TypeContext ctx)

    - #### @Override public GenericsType visitTypeArgument(org.apache.groovy.parser.antlr4.GroovyParser$TypeArgumentContext ctx)

    - #### @Override public GenericsType[] visitTypeArguments(org.apache.groovy.parser.antlr4.GroovyParser$TypeArgumentsContext ctx)

    - #### @Override public GenericsType[] visitTypeArgumentsOrDiamond(org.apache.groovy.parser.antlr4.GroovyParser$TypeArgumentsOrDiamondContext ctx)

    - #### @Override public ClassNode[] visitTypeBound(org.apache.groovy.parser.antlr4.GroovyParser$TypeBoundContext ctx)

    - #### @Override public ClassNode visitTypeDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$TypeDeclarationContext ctx)

    - #### @Override public ClassNode[] visitTypeList(org.apache.groovy.parser.antlr4.GroovyParser$TypeListContext ctx)

    - #### @Override public VariableExpression visitTypeNamePair(org.apache.groovy.parser.antlr4.GroovyParser$TypeNamePairContext ctx)

    - #### @Override public List<Expression> visitTypeNamePairs(org.apache.groovy.parser.antlr4.GroovyParser$TypeNamePairsContext ctx)

    - #### @Override public GenericsType visitTypeParameter(org.apache.groovy.parser.antlr4.GroovyParser$TypeParameterContext ctx)

    - #### @Override public GenericsType[] visitTypeParameters(org.apache.groovy.parser.antlr4.GroovyParser$TypeParametersContext ctx)

    - #### @Override public Expression visitUnaryAddExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$UnaryAddExprAltContext ctx)

    - #### @Override public Expression visitUnaryNotExprAlt(org.apache.groovy.parser.antlr4.GroovyParser$UnaryNotExprAltContext ctx)

    - #### @Override public AstBuilder.DeclarationListStatement visitVariableDeclaration(org.apache.groovy.parser.antlr4.GroovyParser$VariableDeclarationContext ctx)

    - #### @Override public DeclarationExpression visitVariableDeclarator(org.apache.groovy.parser.antlr4.GroovyParser$VariableDeclaratorContext ctx)

    - #### @Override public VariableExpression visitVariableDeclaratorId(org.apache.groovy.parser.antlr4.GroovyParser$VariableDeclaratorIdContext ctx)

    - #### @Override public List<DeclarationExpression> visitVariableDeclarators(org.apache.groovy.parser.antlr4.GroovyParser$VariableDeclaratorsContext ctx)

    - #### @Override public Expression visitVariableInitializer(org.apache.groovy.parser.antlr4.GroovyParser$VariableInitializerContext ctx)

    - #### @Override public List<Expression> visitVariableInitializers(org.apache.groovy.parser.antlr4.GroovyParser$VariableInitializersContext ctx)

    - #### @Override public ModifierNode visitVariableModifier(org.apache.groovy.parser.antlr4.GroovyParser$VariableModifierContext ctx)

    - #### @Override public List<ModifierNode> visitVariableModifiers(org.apache.groovy.parser.antlr4.GroovyParser$VariableModifiersContext ctx)

    - #### @Override public List<ModifierNode> visitVariableModifiersOpt(org.apache.groovy.parser.antlr4.GroovyParser$VariableModifiersOptContext ctx)

    - #### @Override public TupleExpression visitVariableNames(org.apache.groovy.parser.antlr4.GroovyParser$VariableNamesContext ctx)

    - #### @Override public WhileStatement visitWhileStmtAlt(org.apache.groovy.parser.antlr4.GroovyParser$WhileStmtAltContext ctx)

    - #### @Override public ReturnStatement visitYieldStatement(YieldStatementContext ctx)

    - #### @Override public ReturnStatement visitYieldStmtAlt(YieldStmtAltContext ctx)